@setlocal DisableDelayedExpansion
@echo off
set "SysPath=%SystemRoot%\System32"
if exist "%SystemRoot%\Sysnative\reg.exe" (set "SysPath=%SystemRoot%\Sysnative")
set "Path=%SysPath%;%SystemRoot%;%SysPath%\Wbem;%SysPath%\WindowsPowerShell\v1.0\"
set "_err===== ERROR ===="
set "xPA=amd64"
set "xSU=superUser64.exe"
if /i %PROCESSOR_ARCHITECTURE%==x86 (if not defined PROCESSOR_ARCHITEW6432 (
  set "xPA=x86"
  set "xSU=superUser32.exe"
  )
)
set "_pkg=Package_for_KB4528069~31bf3856ad364e35~%xPA%~~6.1.1.1"

reg query HKU\S-1-5-19 1>nul 2>nul || goto :E_Admin
for /f "tokens=6 delims=[]. " %%# in ('ver') do if not %%#==7601 goto :E_Win

set "_work=%~dp0bin\"
setlocal EnableDelayedExpansion
pushd "!_work!"
set "_bins=%xSU%,amd64_KB4528069.reg,x86_KB4528069.reg"
for %%# in (%_bins%) do (
if not exist ".\%%#" (set _file=%%#&goto :E_DLL)
)

if exist "%SystemRoot%\Servicing\Packages\%_pkg%.mum" (
echo.
echo Update KB4528069 Package is already installed.
goto :TheEnd
)

if exist "%SystemRoot%\WinSxS\pending.xml" (
echo.
echo Pending update operation detected.
echo restart the system first, then run the script.
goto :TheEnd
)

:OK
echo.
choice /C YN /N /M "KB4528069 Package Lite will be installed. Continue? [y/n]: "
if errorlevel 2 exit

echo.
echo ____________________________________________________________
echo.
echo Installing . . .
echo.
call :StopService TrustedInstaller 1>nul 2>nul
call :StopService wuauserv 1>nul 2>nul
net start TrustedInstaller 1>nul 2>nul
1>nul 2>nul %xSU% /w /c cmd.exe /c copy /y %xPA%_*6.1.7602.20587*.manifest %SystemRoot%\WinSxS\Manifests\
if not exist "%SystemRoot%\WinSxS\Manifests\%xPA%_microsoft-windows-s..edsecurityupdatesai_31bf3856ad364e35_6.1.7602.20587*.manifest" (
echo.
echo %_err%
echo Failed copying the needed manifest.
echo rerun the script, or restart the system and try again.
goto :TheEnd
)
reg query HKLM\COMPONENTS 1>nul 2>nul || reg load HKLM\COMPONENTS %SysPath%\Config\COMPONENTS 1>nul 2>nul
reg import %xPA%_KB4528069.reg 1>nul 2>nul
for /f "tokens=* delims=" %%# in ('reg query HKLM\COMPONENTS\DerivedData\VersionedIndex ^| findstr /i VersionedIndex') do reg delete "%%#" /f 1>nul 2>nul
reg unload HKLM\COMPONENTS 1>nul 2>nul || call :StopService TrustedInstaller 1>nul 2>nul
dism.exe /Online /Get-Packages 1>nul 2>nul
echo.
echo Done.
goto :TheEnd

:StopService
wmic service %1 call StopService
sc query %1 | find /i "STOPPED" || net stop %1 /y
sc query %1 | find /i "STOPPED" || sc stop %1
exit /b

:E_Admin
echo %_err%
echo This script requires administrator privileges.
goto :TheEnd

:E_Win
echo %_err%
echo This project is for Windows 7 SP1 only.
goto :TheEnd

:E_DLL
echo %_err%
echo Required file bin\%_file% is missing.

:TheEnd
echo.
echo Press any key to exit.
pause >nul
goto :eof
