@setlocal DisableDelayedExpansion
@echo off
set "SysPath=%SystemRoot%\System32"
if exist "%SystemRoot%\Sysnative\reg.exe" (set "SysPath=%SystemRoot%\Sysnative")
set "Path=%SysPath%;%SystemRoot%;%SysPath%\Wbem;%SysPath%\WindowsPowerShell\v1.0\"
set "_err===== ERROR ===="
set "xSU=superUser64.exe"
if /i %PROCESSOR_ARCHITECTURE%==x86 (if not defined PROCESSOR_ARCHITEW6432 (
  set "xSU=superUser32.exe"
  )
)

reg query HKU\S-1-5-19 1>nul 2>nul || goto :E_Admin
rem for /f "tokens=6 delims=[]. " %%# in ('ver') do if not %%#==7601 goto :E_Win

set "_work=%~dp0bin\"
setlocal EnableDelayedExpansion
pushd "!_work!"
set "_bins=%xSU%,amd64_KB4528069.reg,x86_KB4528069.reg"
for %%# in (%_bins%) do (
if not exist ".\%%#" (set _file=%%#&goto :E_DLL)
)

:OK
echo.
echo Enter mounted directory path / offline image drive letter:
echo.
set /p target=
if not defined target exit /b
set "target=%target:"=%"
if "%target:~-1%"=="\" set "target=%target:~0,-1%"
if not exist "%target%\Windows\explorer.exe" (
echo.
echo %_err%
echo Specified path is not valid Windows image
goto :TheEnd
)
dir /b "%target%\Windows\Servicing\Version\6.1.*" 1>nul 2>nul || (
echo.
echo %_err%
echo Specified image path is not Windows 7
goto :TheEnd
)
if exist "%target%\Windows\Servicing\Packages\Package_for_KB4528069*.mum" (
echo.
echo %_err%
echo Update KB4528069 Package is already installed in image
goto :TheEnd
)
echo.
echo ____________________________________________________________
echo.
echo Installing . . .
echo.
if exist "%target%\Windows\Servicing\Packages\*amd64*.mum" (
set "xPA=amd64"
) else (
set "xPA=x86"
)
set "_pkg=Package_for_KB4528069~31bf3856ad364e35~%xPA%~~6.1.1.1"

net start TrustedInstaller 1>nul 2>nul
1>nul 2>nul %xSU% /w /c cmd.exe /c copy /y %xPA%_*6.1.7602.20587*.manifest %target%\Windows\WinSxS\Manifests\
if not exist "%target%\Windows\WinSxS\Manifests\%xPA%_microsoft-windows-s..edsecurityupdatesai_31bf3856ad364e35_6.1.7602.20587*.manifest" (
echo.
echo %_err%
echo Failed copying the needed manifest.
echo rerun the script again.
goto :TheEnd
)
copy /y %xPA%_KB4528069.reg KB4528069.reg >nul
call Reg2Wim.cmd KB4528069.reg
reg load HKLM\wCOMPONENTS "%target%\Windows\System32\config\COMPONENTS" >nul
reg load HKLM\wSOFTWARE "%target%\Windows\System32\config\SOFTWARE" >nul
reg import KB4528069.reg >nul
reg unload HKLM\wCOMPONENTS >nul
reg unload HKLM\wSOFTWARE >nul
del /f /q KB4528069.reg >nul
echo.
echo Done.
goto :TheEnd

:E_Admin
echo %_err%
echo This script requires administrator privileges.
goto :TheEnd

:E_Win
echo %_err%
echo This project is for Windows 7 SP1 only.
goto :TheEnd

:E_DLL
echo %_err%
echo Required file bin\%_file% is missing.

:TheEnd
echo.
echo Press any key to exit.
pause >nul
goto :eof
